//
//  cvMinEnclosingCircle()
//
//
// http://robocraft.ru
//

#include <cv.h>
#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>

void EnclosingCircle(IplImage* _image)
{
	assert(_image!=0);

	IplImage* bin = cvCreateImage( cvGetSize(_image), IPL_DEPTH_8U, 1);

	//    
	cvConvertImage(_image, bin, CV_BGR2GRAY);
	//  
	cvCanny(bin, bin, 50, 200);

	cvNamedWindow( "bin", 1 );
	cvShowImage("bin", bin);

	//    
	CvMemStorage* storage = cvCreateMemStorage(0);
	CvSeq* contours=0;

	//  
	int contoursCont = cvFindContours( bin, storage,&contours,sizeof(CvContour),CV_RETR_LIST,CV_CHAIN_APPROX_SIMPLE,cvPoint(0,0));

	assert(contours!=0);

	//   
	for( CvSeq* current = contours; current != NULL; current = current->h_next ){
		CvPoint2D32f center;
		float radius=0;
		//   
		cvMinEnclosingCircle(current, &center, &radius);
		// 
		cvCircle(_image, cvPointFrom32f(center), radius, CV_RGB(255, 0, 0), 1, 8);
	}

	//  
	cvReleaseMemStorage(&storage);
	cvReleaseImage(&bin);
}

int main(int argc, char* argv[])
{
	IplImage *src=0, *dst=0;

	//     
	char* filename = argc >= 2 ? argv[1] : "Image0.jpg";
	//  
	src = cvLoadImage(filename, 1);

	printf("[i] image: %s\n", filename);
	assert( src != 0 );

	//  
	cvNamedWindow( "original", 1 );
	cvShowImage( "original", src );

	dst = cvCloneImage(src);

	// 
	EnclosingCircle(dst);

	cvNamedWindow( "circles", 1 );
	cvShowImage( "circles", dst);

	//   
	cvWaitKey(0);

	//  
	cvReleaseImage(&src);
	cvReleaseImage(&dst);
	//  
	cvDestroyAllWindows();
	return 0;
}
